package info.hostip.dao.mgr;

import java.util.Vector;
import java.sql.*;
import info.hostip.dao.core.*;

/******************SQL2JAVA_IMPORT_BEGIN******************/

/******************SQL2JAVA_IMPORT_END********************/


/** This is the dao class.
 * @author <a href="mailto:vinodpillai@excite.com">Vinod Pillai</a>
 */
public class Ip4Manager extends Manager
/******************SQL2JAVA_EXTENDS_BEGIN******************/

/******************SQL2JAVA_EXTENDS_END********************/

{

/******************SQL2JAVA_CLASS_BEGIN******************/

/******************SQL2JAVA_CLASS_END********************/


	private static Ip4Manager _global = new Ip4Manager();
	public static Ip4Manager getManager() { return _global; }

	public static final int IP = 0;
	public static final int COUNTRY = 1;
	public static final int CITY = 2;
	public static final int CRON = 3;

	private static final String[] S2J_FIELD_NAMES = {
		"ip4.ip",
		"ip4.country",
		"ip4.city",
		"ip4.cron"
	};

	private static final String ALL_FIELDS = "ip4.ip"
                            + ",ip4.country"
                            + ",ip4.city"
                            + ",ip4.cron";

	public Ip4[] loadAll() throws SQLException {
		Connection _conn = null;
		try {
			_conn = openConnection();
			Ip4 _list[] = loadAll(_conn);
			closeConnection(_conn);
			return _list;
		}
		catch(SQLException e) {
			if(_conn != null)  try { closeConnection(_conn); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Ip4[] loadAll(Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			_pstmt = _conn.prepareStatement("SELECT " + ALL_FIELDS + " FROM ip4");
			Ip4 _list[] = loadByPreparedStatement(_pstmt);
			_pstmt.close();
			return _list;
		}
		catch(SQLException e) {
			if(_pstmt != null) try { _pstmt.close(); } catch(SQLException e2) { }
			throw e;
		}
	}

	public Ip4[] loadByPreparedStatement(PreparedStatement pstmt) throws SQLException {
		return loadByPreparedStatement(pstmt, null, 0);
	}

	public Ip4[] loadByPreparedStatement(PreparedStatement pstmt, int maxRows) throws SQLException {
		return loadByPreparedStatement(pstmt, null, maxRows);
	}

	public Ip4[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList) throws SQLException {
		return loadByPreparedStatement(pstmt, fieldList, 0);
	}

	public Ip4[] loadByPreparedStatement(PreparedStatement pstmt, int[] fieldList, int maxRows) throws SQLException {
		ResultSet rs = null;
		try {
			rs = pstmt.executeQuery();
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			Ip4 list[] = new Ip4[v.size()];
			v.copyInto(list);
			return list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public Ip4[] loadByWhere(String where) throws SQLException {
		return loadByWhere(where, (int[])null, 0);
	}
	public Ip4[] loadByWhere(String where, int maxRows) throws SQLException {
		return loadByWhere(where, (int[])null, maxRows);
	}
	public Ip4[] loadByWhere(String where, int[] fieldList) throws SQLException {
		return loadByWhere(where, fieldList, 0);
	}
	public Ip4[] loadByWhere(String where, int[] fieldList, int maxRows) throws SQLException {
		Connection conn = null;
		try {
			conn = openConnection();
			Ip4 _list[] = loadByWhere(where, conn, fieldList, maxRows);
			closeConnection(conn);
			return _list;
		}
		catch(SQLException e) {
			if(conn!=null) try { closeConnection(conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public Ip4[] loadByWhere(String where, Connection conn) throws SQLException {
		return loadByWhere(where, conn, null, 0);
	}

	public Ip4[] loadByWhere(String where, Connection conn, int[] fieldList) throws SQLException {
		return loadByWhere(where, conn, fieldList, 0);
	}

	public Ip4[] loadByWhere(String where, Connection conn, int[] fieldList, int maxRows) throws SQLException {
		String sql = null;
		if(fieldList == null) sql = "select " + ALL_FIELDS + " from ip4 " + where;
		else {
			StringBuffer buff = new StringBuffer(128);
			buff.append("select ");
			for(int i = 0; i < fieldList.length; i++) {
				if(i != 0) buff.append(",");
				buff.append(S2J_FIELD_NAMES[fieldList[i]]);
			}
			buff.append(" from ip4 ");
			buff.append(where);
			sql = buff.toString();
		}
		Statement stmt = null;
		ResultSet rs = null;
		try {
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
			java.util.Vector v = new java.util.Vector();
			while(rs.next() && (maxRows == 0 || v.size() < maxRows)) {
				if(fieldList == null) v.addElement(decodeRow(rs));
				else v.addElement(decodeRow(rs, fieldList));
			}
			rs.close();
			stmt.close();

			Ip4 _list[] = new Ip4[v.size()];
			v.copyInto(_list);
			return _list;
		}
		catch(SQLException e) {
			if(rs!=null) try { rs.close();} catch(Exception e2) {}
			if(stmt!=null) try { stmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Ip4 obj) throws SQLException {
		if(!obj.isModified()) return;
		Connection _conn = null;
		try {
			_conn = openConnection();
			save(obj, _conn);
			closeConnection(_conn);
		}
		catch(SQLException e) {
			if(_conn!=null) try { closeConnection(_conn);} catch(Exception e2) {}
			throw e;
		}
	}

	public void save(Ip4 obj, Connection _conn) throws SQLException {
		PreparedStatement _pstmt = null;
		try {
			if(obj.isNew()) {
				int _dirtyCount = 0;
				StringBuffer _sql = new StringBuffer("INSERT into ip4 (");
				if(obj.isIpModified()) {  _sql.append("ip").append(","); _dirtyCount++; }
				if(obj.isCountryModified()) {  _sql.append("country").append(","); _dirtyCount++; }
				if(obj.isCityModified()) {  _sql.append("city").append(","); _dirtyCount++; }
				if(obj.isCronModified()) {  _sql.append("cron").append(","); _dirtyCount++; }
				_sql.setLength(_sql.length() - 1);
				_sql.append(") values (");
				for(int i = 0; i < _dirtyCount; i++) _sql.append("?,");
				_sql.setLength(_sql.length() - 1);
				_sql.append(")");

				_pstmt = _conn.prepareStatement(_sql.toString());
				_dirtyCount = 0;
				if(obj.isIpModified()) { _pstmt.setLong(++_dirtyCount, obj.getIp()); } 
				if(obj.isCountryModified()) { _pstmt.setInt(++_dirtyCount, obj.getCountry()); } 
				if(obj.isCityModified()) { _pstmt.setInt(++_dirtyCount, obj.getCity()); } 
				if(obj.isCronModified()) { _pstmt.setTimestamp(++_dirtyCount, new java.sql.Timestamp(obj.getCron().getTime())); } 
				_pstmt.executeUpdate();
				obj.setIsNew(false);
				obj.resetIsModified();
			}
			_pstmt.close();
		}
		catch(SQLException e) {
			if(_pstmt!=null) try { _pstmt.close();} catch(Exception e2) {}
			throw e;
		}
	}

	private Ip4 decodeRow(ResultSet rs) throws SQLException {
		Ip4 obj = new Ip4();
		obj.setIp(rs.getInt(1));
		obj.setCountry(rs.getInt(2));
		obj.setCity(rs.getInt(3));
		obj.setCron(rs.getTimestamp(4));
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

	private Ip4 decodeRow(ResultSet rs, int[] fieldList) throws SQLException {
		Ip4 obj = new Ip4();
		int pos = 0;
		for(int i = 0; i < fieldList.length; i++) {
			switch(fieldList[i]) {
				case IP: obj.setIp(rs.getInt(++pos));
					break;
				case COUNTRY: obj.setCountry(rs.getInt(++pos));
					break;
				case CITY: obj.setCity(rs.getInt(++pos));
					break;
				case CRON: obj.setCron(rs.getTimestamp(++pos));
					break;
			}
		}
		obj.setIsNew(false);
		obj.resetIsModified();

		return obj;
	}

}
